using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata;

namespace WebApplication1
{
    public partial class ioma_recetaContext : DbContext
    {
        public ioma_recetaContext()
        {
        }

        public ioma_recetaContext(DbContextOptions<ioma_recetaContext> options)
            : base(options)
        {
        }

        public virtual DbSet<RecetaPrescripcion> RecetaPrescripcions { get; set; } = null!;
        public virtual DbSet<RecetaRecetum> RecetaReceta { get; set; } = null!;

        //        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        //        {
        //            if (!optionsBuilder.IsConfigured)
        //            {
        //#warning To protect potentially sensitive information in your connection string, you should move it out of source code. You can avoid scaffolding the connection string by using the Name= syntax to read it from configuration - see https://go.microsoft.com/fwlink/?linkid=2131148. For more guidance on storing connection strings, see http://go.microsoft.com/fwlink/?LinkId=723263.
        //                optionsBuilder.UseSqlServer("Server=ntserver6-d;Initial Catalog=ioma_receta;Persist Security Info=False;User ID=userconsulta;Password=userconsultapass;MultipleActiveResultSets=False;Encrypt=True;TrustServerCertificate=True;Connection Timeout=30;");
        //            }
        //        }

        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
            if (!optionsBuilder.IsConfigured)
            {
                // Leemos la configuración
                var config = new ConfigurationBuilder()
                    .SetBasePath(Directory.GetCurrentDirectory()) // ruta base
                    .AddJsonFile("appsettings.json")
                    .Build();

                // Obtenemos la cadena de conexión desde ConnectionStrings
                var connectionString = config.GetConnectionString("DefaultConnection");

                // La usamos en UseSqlServer
                optionsBuilder.UseSqlServer(connectionString);
            }
        }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.UseCollation("Modern_Spanish_CI_AS");

            modelBuilder.Entity<RecetaPrescripcion>(entity =>
            {
                entity.ToTable("receta_prescripcion");

                entity.HasIndex(e => e.DiagnosticoId, "receta_prescripcion_diagnostico_id_4d07f9d2")
                    .HasFillFactor(80);

                entity.HasIndex(e => e.MedicamentoId, "receta_prescripcion_medicamento_id_29fca186")
                    .HasFillFactor(80);

                entity.HasIndex(e => e.TipoPrescripcion, "receta_prescripcion_tipo_prescripcion_47d21f20")
                    .HasFillFactor(80);

                entity.Property(e => e.Id).HasColumnName("id");

                entity.Property(e => e.CantidadSegunPresentacion).HasColumnName("cantidad_segun_presentacion");

                entity.Property(e => e.DiagnosticoId).HasColumnName("diagnostico_id");

                entity.Property(e => e.DosisDia)
                    .HasMaxLength(75)
                    .HasColumnName("dosis_dia");

                entity.Property(e => e.DosisUnidad)
                    .HasMaxLength(75)
                    .HasColumnName("dosis_unidad");

                entity.Property(e => e.DuracionTratamiento).HasColumnName("duracion_tratamiento");

                entity.Property(e => e.Justificacion).HasColumnName("justificacion");

                entity.Property(e => e.MedicamentoId).HasColumnName("medicamento_id");

                entity.Property(e => e.TipoPrescripcion)
                    .HasMaxLength(10)
                    .HasColumnName("tipo_prescripcion");
            });

            modelBuilder.Entity<RecetaRecetum>(entity =>
            {
                entity.ToTable("receta_receta");

                entity.HasIndex(e => e.Prescripcion1Id, "UQ__receta_r__1F9DE7A2DAA0BB17")
                    .IsUnique();

                entity.HasIndex(e => e.NroReceta, "receta_receta_nro_receta_52c962be")
                    .HasFillFactor(80);

                entity.HasIndex(e => e.Prescripcion2Id, "receta_receta_prescripcion_2_id_b9229389_uniq")
                    .IsUnique()
                    .HasFilter("([prescripcion_2_id] IS NOT NULL)")
                    .HasFillFactor(80);

                entity.HasIndex(e => e.PrestadorId, "receta_receta_prestador_id_d6701866")
                    .HasFillFactor(80);

                entity.HasIndex(e => e.ProfesionalId, "receta_receta_profesional_id_e344c2eb")
                    .HasFillFactor(80);

                entity.HasIndex(e => e.Sexo, "receta_receta_sexo_c3d4645d")
                    .HasFillFactor(80);

                entity.HasIndex(e => e.TProvinciaEmisoraId, "receta_receta_t_provincia_emisora_id_78157693")
                    .HasFillFactor(80);

                entity.HasIndex(e => e.TipoTratamiento, "receta_receta_tipo_tratamiento_e6ee9c8d")
                    .HasFillFactor(80);

                entity.Property(e => e.Id).HasColumnName("id");

                entity.Property(e => e.ApellidoNombre)
                    .HasMaxLength(50)
                    .HasColumnName("apellido_nombre");

                entity.Property(e => e.CantidadRecetas).HasColumnName("cantidad_recetas");

                entity.Property(e => e.CodPrescripcion).HasColumnName("cod_prescripcion");

                entity.Property(e => e.Code128NroAfiliado)
                    .HasMaxLength(100)
                    .HasColumnName("code128_nro_afiliado");

                entity.Property(e => e.Code128NroReceta)
                    .HasMaxLength(100)
                    .HasColumnName("code128_nro_receta");

                entity.Property(e => e.Edad).HasColumnName("edad");

                entity.Property(e => e.Estado)
                    .HasMaxLength(30)
                    .HasColumnName("estado");

                entity.Property(e => e.Fecha)
                    .HasColumnType("date")
                    .HasColumnName("fecha");

                entity.Property(e => e.FechaGeneracion).HasColumnName("fecha_generacion");

                entity.Property(e => e.IdAfiliado).HasColumnName("id_afiliado");

                entity.Property(e => e.IdSwitch)
                    .HasMaxLength(100)
                    .HasColumnName("id_switch");

                entity.Property(e => e.Indicaciones).HasColumnName("indicaciones");

                entity.Property(e => e.NroAfiliado)
                    .HasMaxLength(12)
                    .HasColumnName("nro_afiliado");

                entity.Property(e => e.NroDocumento).HasColumnName("nro_documento");

                entity.Property(e => e.NroOrdenConsulta)
                    .HasMaxLength(15)
                    .HasColumnName("nro_orden_consulta");

                entity.Property(e => e.NroReceta)
                    .HasMaxLength(13)
                    .HasColumnName("nro_receta");

                entity.Property(e => e.Peso).HasColumnName("peso");

                entity.Property(e => e.Prescripcion1Id).HasColumnName("prescripcion_1_id");

                entity.Property(e => e.Prescripcion2Id).HasColumnName("prescripcion_2_id");

                entity.Property(e => e.PrestadorId).HasColumnName("prestador_id");

                entity.Property(e => e.ProfesionalId).HasColumnName("profesional_id");

                entity.Property(e => e.Sexo)
                    .HasMaxLength(1)
                    .HasColumnName("sexo");

                entity.Property(e => e.TEspecialidadId).HasColumnName("t_especialidad_id");

                entity.Property(e => e.TMatriculaNacional).HasColumnName("t_matricula_nacional");

                entity.Property(e => e.TMatriculaProvincial).HasColumnName("t_matricula_provincial");

                entity.Property(e => e.TProfesionId).HasColumnName("t_profesion_id");

                entity.Property(e => e.TProfesionalApellido)
                    .HasMaxLength(25)
                    .HasColumnName("t_profesional_apellido");

                entity.Property(e => e.TProfesionalNombre)
                    .HasMaxLength(25)
                    .HasColumnName("t_profesional_nombre");

                entity.Property(e => e.TProvinciaEmisoraId).HasColumnName("t_provincia_emisora_id");

                entity.Property(e => e.TProvinciaEmisoraPrescripcion).HasColumnName("t_provincia_emisora_prescripcion");

                entity.Property(e => e.TipoTratamiento)
                    .HasMaxLength(10)
                    .HasColumnName("tipo_tratamiento");

                entity.Property(e => e.Token)
                    .HasMaxLength(8)
                    .HasColumnName("token");

                entity.HasOne(d => d.Prescripcion1)
                    .WithOne(p => p.RecetaRecetumPrescripcion1)
                    .HasForeignKey<RecetaRecetum>(d => d.Prescripcion1Id)
                    .OnDelete(DeleteBehavior.ClientSetNull)
                    .HasConstraintName("receta_receta_prescripcion_1_id_eb1754dc_fk_receta_prescripcion_id");

                entity.HasOne(d => d.Prescripcion2)
                    .WithOne(p => p.RecetaRecetumPrescripcion2)
                    .HasForeignKey<RecetaRecetum>(d => d.Prescripcion2Id)
                    .HasConstraintName("receta_receta_prescripcion_2_id_b9229389_fk_receta_prescripcion_id");
            });

            OnModelCreatingPartial(modelBuilder);
        }

        partial void OnModelCreatingPartial(ModelBuilder modelBuilder);
    }
}
